/******************************************************************************
*                                                                             *
*   E a s y C h a r                                                           *
*                                                                             *
*   by Stefan Heule                                                           *
*   member of boolsoft (www.boolsoft.org)                                     *
*                                                                             *
*   Source Code                                                               *
*                                                                             *
*******************************************************************************

EasyChar - Replacement of the standard char menu
Copyright (C) 2007-2010  Stefan Heule

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/



// ----------------------------------------------------------------- //
// --- header files
// ----------------------------------------------------------------- //
#include "header.h"



// ----------------------------------------------------------------- //
// copies the content of the backbuffer <screen> onto the real screen
// ----------------------------------------------------------------- //
void switchBackbuffer(void)
{
	static unsigned char i;
	
	for (i = 0; i < 95; i++)
		memcpy(LCD_MEM+(i+OFFSET_Y)*30+OFFSET_X, screen+i*18, 18);
}

// ----------------------------------------------------------------- //
// draws a dialog with the coordinates <x0/y0> and <x1/y1> and the
// title <title>
// ----------------------------------------------------------------- //
void DrawDialog(short x0, short y0, short x1, short y1, const char* title)
{
	// background (white)
	DrawRect(x0+1, y0+7, x1-1, y1-1, 1, 0);
	
	// titelbar
	DrawRect(x0, y0+2, x1, y0+6, 1, 1);
	DrawLine(x0+2,y0 ,x1-2, y0, 1);
	DrawLine(x0+1, y0+1, x1-1, y0+1, 1);
	
	// border arround
	DrawLine(x0+2, y1, x1-2, y1, 1);
	DrawLine(x0, y0+7,x0 ,y1-2, 1);
	DrawLine(x1, y0+7,x1 ,y1-2, 1);
	DrawPix(x0+1, y1-1, 1);
	DrawPix(x1-1, y1-1, 1);
	
	// border inside the window
	DrawRect(x0+2, y0+8, x1-2, y1-2, 0, 1);
	
	// title
	FontSetSys(F_4x6);
	DrawStr((x0+x1-DrawStrWidth(title, F_4x6))/2, y0+1, title, A_XOR);
};

// ----------------------------------------------------------------- //
// draws a rect with the coordinates <x0/y0> and <x1/y1>
// if <fill> is 0, the rect will be outlined, else filled
// <color> = 1: normal
// <color> = 2: double border
// <color> = 3: xor
// else:        erase
// ----------------------------------------------------------------- //
void DrawRect(short x0, short y0, short x1, short y1, short fill, short color)
{
	short att;
	if (color == 1)      att = A_NORMAL;
	else if (color == 2) att = A_NORMAL | B_DOUBLE;
	else if (color == 3) att = A_XOR;
	else                 att = A_REVERSE;
	
	/*if (x1 == -1)
	{
		x1 = LCD_WIDTH/2 + x0/2;
		x0 = (LCD_WIDTH - x0)/2;
	}
	
	if (y1 == -1)
	{
		y1 = LCD_HEIGHT/2 + y0/2;
		y0 = (LCD_HEIGHT - y0)/2;
	}*/
	
	if (fill)
		ScrRectFill(&(SCR_RECT){{x0, y0, x1, y1}}, &(SCR_RECT){{0, 0, 144, 95}}, att);
	else
		DrawClipRect (&(WIN_RECT){x0, y0, x1, y1}, &(SCR_RECT){{0, 0, 144, 95}}, att);
};



















